<template>
    <i-form :model="this.data" class='app-form info-form-mode' ref='form'  id='emitem_store' style="">
    <input style="display:none;" />
    <row >
            
<i-col v-show="detailsModel.grouppanel15.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group :manageContainerStatus="detailsModel.grouppanel15.manageContainerStatus"  :isManageContainer="detailsModel.grouppanel15.isManageContainer" @managecontainerclick="manageContainerClick('grouppanel15')" layoutType="TABLE_24COL" titleStyle="" class='' :uiActionGroup="detailsModel.grouppanel15.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emitem.store_form.details.grouppanel15')" :isShowCaption="false" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="true" >    
    <row>
        <i-col v-show="detailsModel.storename.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='storename' :itemRules="this.rules.storename" class='' :caption="$t('entities.emitem.store_form.details.storename')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.storename.error" :isEmptyCaption="false" labelPos="LEFT">
    
<app-span name='storename' :value="data.storename" :data="data" :context="context" :viewparams="viewparams" :localContext ='{ }'  :localParam ='{ }'  style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.storepartname.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='storepartname' :itemRules="this.rules.storepartname" class='' :caption="$t('entities.emitem.store_form.details.storepartname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.storepartname.error" :isEmptyCaption="false" labelPos="LEFT">
    
<app-span name='storepartname' :value="data.storepartname" :data="data" :context="context" :viewparams="viewparams" :localContext ='{ }'  :localParam ='{ }'  style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.stocksum.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='stocksum' :itemRules="this.rules.stocksum" class='' :caption="$t('entities.emitem.store_form.details.stocksum')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.stocksum.error" :isEmptyCaption="false" labelPos="LEFT">
    
<app-span name='stocksum' :value="data.stocksum" :data="data" :context="context" :viewparams="viewparams" :localContext ='{ }'  :localParam ='{ }'  style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.unitname.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='unitname' :itemRules="this.rules.unitname" class='' :caption="$t('entities.emitem.store_form.details.unitname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.unitname.error" :isEmptyCaption="false" labelPos="LEFT">
    
<app-span name='unitname' :value="data.unitname" :data="data" :context="context" :viewparams="viewparams" :localContext ='{ }'  :localParam ='{ }'  style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.price.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='price' :itemRules="this.rules.price" class='' :caption="$t('entities.emitem.store_form.details.price')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.price.error" :isEmptyCaption="false" labelPos="LEFT">
    
<app-span name='price' :value="data.price" :data="data" :context="context" :viewparams="viewparams" :localContext ='{ }'  :localParam ='{ }'  style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.amount.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='amount' :itemRules="this.rules.amount" class='' :caption="$t('entities.emitem.store_form.details.amount')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.amount.error" :isEmptyCaption="false" labelPos="LEFT">
    
<app-span name='amount' :value="data.amount" :data="data" :context="context" :viewparams="viewparams" :localContext ='{ }'  :localParam ='{ }'  style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.lastsum.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='lastsum' :itemRules="this.rules.lastsum" class='' :caption="$t('entities.emitem.store_form.details.lastsum')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.lastsum.error" :isEmptyCaption="false" labelPos="LEFT">
    
<app-span name='lastsum' :value="data.lastsum" :data="data" :context="context" :viewparams="viewparams" :localContext ='{ }'  :localParam ='{ }'  style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.highsum.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='highsum' :itemRules="this.rules.highsum" class='' :caption="$t('entities.emitem.store_form.details.highsum')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.highsum.error" :isEmptyCaption="false" labelPos="LEFT">
    
<app-span name='highsum' :value="data.highsum" :data="data" :context="context" :viewparams="viewparams" :localContext ='{ }'  :localParam ='{ }'  style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.repsum.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='repsum' :itemRules="this.rules.repsum" class='' :caption="$t('entities.emitem.store_form.details.repsum')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.repsum.error" :isEmptyCaption="false" labelPos="LEFT">
    
<app-span name='repsum' :value="data.repsum" :data="data" :context="context" :viewparams="viewparams" :localContext ='{ }'  :localParam ='{ }'  style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.abctype.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='abctype' :itemRules="this.rules.abctype" class='' :caption="$t('entities.emitem.store_form.details.abctype')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.abctype.error" :isEmptyCaption="false" labelPos="LEFT">
    
<app-span name='abctype' :value="data.abctype" tag='EMABCTYPE' codelistType='STATIC' :data="data" :context="context" :viewparams="viewparams" :localContext ='{ }'  :localParam ='{ }'  style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.lastprice.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='lastprice' :itemRules="this.rules.lastprice" class='' :caption="$t('entities.emitem.store_form.details.lastprice')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.lastprice.error" :isEmptyCaption="false" labelPos="LEFT">
    
<app-span name='lastprice' :value="data.lastprice" :data="data" :context="context" :viewparams="viewparams" :localContext ='{ }'  :localParam ='{ }'  style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.sempname.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='sempname' :itemRules="this.rules.sempname" class='' :caption="$t('entities.emitem.store_form.details.sempname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.sempname.error" :isEmptyCaption="false" labelPos="LEFT">
    
<app-span name='sempname' :value="data.sempname" :data="data" :context="context" :viewparams="viewparams" :localContext ='{ }'  :localParam ='{ }'  style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.stockinl.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='stockinl' :itemRules="this.rules.stockinl" class='' :caption="$t('entities.emitem.store_form.details.stockinl')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.stockinl.error" :isEmptyCaption="false" labelPos="LEFT">
    
<app-span name='stockinl' :value="data.stockinl" :data="data" :context="context" :viewparams="viewparams" :localContext ='{ }'  :localParam ='{ }'  style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.lastindate.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='lastindate' :itemRules="this.rules.lastindate" class='' :caption="$t('entities.emitem.store_form.details.lastindate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.lastindate.error" :isEmptyCaption="false" labelPos="LEFT">
    
<app-span name='lastindate' :value="data.lastindate" :data="data" :context="context" :viewparams="viewparams" :localContext ='{ }'  :localParam ='{ }'  style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.lastaempname.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='lastaempname' :itemRules="this.rules.lastaempname" class='' :caption="$t('entities.emitem.store_form.details.lastaempname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.lastaempname.error" :isEmptyCaption="false" labelPos="LEFT">
    
<app-span name='lastaempname' :value="data.lastaempname" :data="data" :context="context" :viewparams="viewparams" :localContext ='{ }'  :localParam ='{ }'  style=""></app-span>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>


    </row>
</i-form>
</template>

<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import AppCenterService from "@service/app/app-center-service";
import EMItemService from '@/service/emitem/emitem-service';
import StoreService from './store-form-service';

import { FormButtonModel, FormPageModel, FormItemModel, FormDRUIPartModel, FormPartModel, FormGroupPanelModel, FormIFrameModel, FormRowItemModel, FormTabPageModel, FormTabPanelModel, FormUserControlModel } from '@/model/form-detail';
import { debounceTime, distinctUntilChanged } from 'rxjs/operators';


@Component({
    components: {
      
    }
})
export default class StoreBase extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof StoreBase
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof StoreBase
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof StoreBase
     */
    @Prop() public context: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof StoreBase
     */
    @Prop() public viewparams: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof StoreBase
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof StoreBase
     */
    public getControlType(): string {
        return 'FORM'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof StoreBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {StoreService}
     * @memberof StoreBase
     */
    public service: StoreService = new StoreService({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {EMItemService}
     * @memberof StoreBase
     */
    public appEntityService: EMItemService = new EMItemService({ $store: this.$store });
    


    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof StoreBase
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof StoreBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }


    /**
     * 视图默认使用
     *
     * @type {string}
     * @memberof StoreBase
     */
    @Inject({from:'navModel',default: 'tab'})
    public navModel!:string;

    /**
     * 工作流审批意见控件绑定值
     *
     * @memberof StoreBase
     */
    public srfwfmemo:string = "";
    
    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof StoreBase
     */
    public getDatas(): any[] {
        return [this.data];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof StoreBase
     */
    public getData(): any {
        return this.data;
    }

    /**
     * 是否默认保存
     *
     * @type {boolean}
     * @memberof StoreBase
     */
    @Prop({ default: false }) public autosave?: boolean;

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof StoreBase
     */
    @Prop({ default: true }) public showBusyIndicator?: boolean;

    /**
     * 部件行为--submit
     *
     * @type {string}
     * @memberof StoreBase
     */
    @Prop() public WFSubmitAction!: string;
    
    /**
     * 部件行为--start
     *
     * @type {string}
     * @memberof StoreBase
     */
    @Prop() public WFStartAction!: string;
    
    /**
     * 部件行为--update
     *
     * @type {string}
     * @memberof StoreBase
     */
    @Prop() public updateAction!: string;
    
    /**
     * 部件行为--remove
     *
     * @type {string}
     * @memberof StoreBase
     */
    @Prop() public removeAction!: string;
    
    /**
     * 部件行为--loaddraft
     *
     * @type {string}
     * @memberof StoreBase
     */
    @Prop() public loaddraftAction!: string;
    
    /**
     * 部件行为--load
     *
     * @type {string}
     * @memberof StoreBase
     */
    @Prop() public loadAction!: string;
    
    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof StoreBase
     */
    @Prop() public createAction!: string;

    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof StoreBase
     */
    @Prop() public searchAction!: string;

    /**
     * 视图标识
     *
     * @type {string}
     * @memberof StoreBase
     */
    @Prop() public viewtag!: string;

    /**
     * 表单状态
     *
     * @type {Subject<any>}
     * @memberof StoreBase
     */
    public formState: Subject<any> = new Subject();

    /**
     * 忽略表单项值变化
     *
     * @type {boolean}
     * @memberof StoreBase
     */
    public ignorefieldvaluechange: boolean = false;

    /**
     * 数据变化
     *
     * @public
     * @type {Subject<any>}
     * @memberof StoreBase
     */
    public dataChang: Subject<any> = new Subject();

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof StoreBase
     */
    public dataChangEvent: Subscription | undefined;

    /**
     * 原始数据
     *
     * @public
     * @type {*}
     * @memberof StoreBase
     */
    public oldData: any = {};

    /**
     * 表单数据对象
     *
     * @type {*}
     * @memberof StoreBase
     */
    public data: any = {
        srfupdatedate: null,
        srforikey: null,
        srfkey: null,
        srfmajortext: null,
        srftempmode: null,
        srfuf: null,
        srfdeid: null,
        srfsourcekey: null,
        storename: null,
        storepartname: null,
        stocksum: null,
        unitname: null,
        price: null,
        amount: null,
        lastsum: null,
        highsum: null,
        repsum: null,
        abctype: null,
        lastprice: null,
        sempid: null,
        sempname: null,
        stockinl: null,
        lastindate: null,
        lastaempid: null,
        lastaempname: null,
        emitemid: null,
        emitem:null,
    };

    /**
      * 当前执行的行为逻辑
      *
      * @type {string}
      * @memberof StoreBase
      */
    public currentAction: string = "";

    /**
      * 关系界面计数器
      *
      * @type {number}
      * @memberof StoreBase
      */
    public drcounter: number = 0;

    /**
      * 需要等待关系界面保存时，第一次调用save参数的备份
      *
      * @type {number}
      * @memberof StoreBase
      */
    public drsaveopt: any = {};

    /**
      * 表单保存回调存储对象
      *
      * @type {any}
      * @memberof StoreBase
      */
    public saveState:any ;

    /**
     * 属性值规则
     *
     * @type {*}
     * @memberof StoreBase
     */
    public rules: any = {
        srfupdatedate: [
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'blur' },
        ],
        srforikey: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfkey: [
            { type: 'string', message: '物品标识 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '物品标识 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '物品标识 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '物品标识 值不能为空', trigger: 'blur' },
        ],
        srfmajortext: [
            { type: 'string', message: '物品名称 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '物品名称 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '物品名称 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '物品名称 值不能为空', trigger: 'blur' },
        ],
        srftempmode: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfuf: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfdeid: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfsourcekey: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        storename: [
            { type: 'string', message: '最新存储仓库 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '最新存储仓库 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '最新存储仓库 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '最新存储仓库 值不能为空', trigger: 'blur' },
        ],
        storepartname: [
            { type: 'string', message: '最新存储库位 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '最新存储库位 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '最新存储库位 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '最新存储库位 值不能为空', trigger: 'blur' },
        ],
        stocksum: [
            { type: 'number', message: '库存量 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '库存量 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '库存量 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '库存量 值不能为空', trigger: 'blur' },
        ],
        unitname: [
            { type: 'string', message: '单位 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '单位 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '单位 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '单位 值不能为空', trigger: 'blur' },
        ],
        price: [
            { type: 'string', message: '平均价 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '平均价 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '平均价 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '平均价 值不能为空', trigger: 'blur' },
        ],
        amount: [
            { type: 'string', message: '库存金额 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '库存金额 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '库存金额 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '库存金额 值不能为空', trigger: 'blur' },
        ],
        lastsum: [
            { type: 'number', message: '最低库存 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '最低库存 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '最低库存 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '最低库存 值不能为空', trigger: 'blur' },
        ],
        highsum: [
            { type: 'number', message: '最高库存 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '最高库存 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '最高库存 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '最高库存 值不能为空', trigger: 'blur' },
        ],
        repsum: [
            { type: 'number', message: '重订量 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '重订量 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '重订量 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '重订量 值不能为空', trigger: 'blur' },
        ],
        abctype: [
            { type: 'string', message: 'ABC分类 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: 'ABC分类 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: 'ABC分类 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: 'ABC分类 值不能为空', trigger: 'blur' },
        ],
        lastprice: [
            { type: 'string', message: '最新价格 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '最新价格 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '最新价格 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '最新价格 值不能为空', trigger: 'blur' },
        ],
        sempid: [
            { type: 'string', message: '库管员 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '库管员 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '库管员 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '库管员 值不能为空', trigger: 'blur' },
        ],
        sempname: [
            { type: 'string', message: '库管员 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '库管员 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '库管员 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '库管员 值不能为空', trigger: 'blur' },
        ],
        stockinl: [
            { type: 'number', message: '库存周期(天) 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '库存周期(天) 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '库存周期(天) 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '库存周期(天) 值不能为空', trigger: 'blur' },
        ],
        lastindate: [
            { type: 'string', message: '最后入料时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '最后入料时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '最后入料时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '最后入料时间 值不能为空', trigger: 'blur' },
        ],
        lastaempid: [
            { type: 'string', message: '最新请购人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '最新请购人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '最新请购人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '最新请购人 值不能为空', trigger: 'blur' },
        ],
        lastaempname: [
            { type: 'string', message: '最新请购人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '最新请购人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '最新请购人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '最新请购人 值不能为空', trigger: 'blur' },
        ],
        emitemid: [
            { type: 'string', message: '物品标识 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '物品标识 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '物品标识 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '物品标识 值不能为空', trigger: 'blur' },
        ],
    }

    /**
     * 详情模型集合
     *
     * @type {*}
     * @memberof StoreBase
     */
    public detailsModel: any = {
        grouppanel15: new FormGroupPanelModel({ caption: '库存信息', detailType: 'GROUPPANEL', name: 'grouppanel15', visible: true, isShowCaption: false, form: this, isControlledContent: false , uiActionGroup: { caption: '', langbase: 'entities.emitem.store_form', extractMode: 'ITEM', details: [] }, isManageContainer: false, showMoreModeItems: []  })
, 
        formpage1: new FormPageModel({ caption: '基本信息', detailType: 'FORMPAGE', name: 'formpage1', visible: true, isShowCaption: true, form: this, isControlledContent: false  })
, 
        srfupdatedate: new FormItemModel({ caption: '更新时间', detailType: 'FORMITEM', name: 'srfupdatedate', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 0 })
, 
        srforikey: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srforikey', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        srfkey: new FormItemModel({ caption: '物品标识', detailType: 'FORMITEM', name: 'srfkey', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 0 })
, 
        srfmajortext: new FormItemModel({ caption: '物品名称', detailType: 'FORMITEM', name: 'srfmajortext', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        srftempmode: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srftempmode', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        srfuf: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfuf', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        srfdeid: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfdeid', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        srfsourcekey: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfsourcekey', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        storename: new FormItemModel({ caption: '最新存储仓库', detailType: 'FORMITEM', name: 'storename', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        storepartname: new FormItemModel({ caption: '最新存储库位', detailType: 'FORMITEM', name: 'storepartname', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        stocksum: new FormItemModel({ caption: '库存量', detailType: 'FORMITEM', name: 'stocksum', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        unitname: new FormItemModel({ caption: '单位', detailType: 'FORMITEM', name: 'unitname', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        price: new FormItemModel({ caption: '平均价', detailType: 'FORMITEM', name: 'price', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        amount: new FormItemModel({ caption: '库存金额', detailType: 'FORMITEM', name: 'amount', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        lastsum: new FormItemModel({ caption: '最低库存', detailType: 'FORMITEM', name: 'lastsum', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        highsum: new FormItemModel({ caption: '最高库存', detailType: 'FORMITEM', name: 'highsum', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        repsum: new FormItemModel({ caption: '重订量', detailType: 'FORMITEM', name: 'repsum', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        abctype: new FormItemModel({ caption: 'ABC分类', detailType: 'FORMITEM', name: 'abctype', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        lastprice: new FormItemModel({ caption: '最新价格', detailType: 'FORMITEM', name: 'lastprice', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        sempid: new FormItemModel({ caption: '库管员', detailType: 'FORMITEM', name: 'sempid', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        sempname: new FormItemModel({ caption: '库管员', detailType: 'FORMITEM', name: 'sempname', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        stockinl: new FormItemModel({ caption: '库存周期(天)', detailType: 'FORMITEM', name: 'stockinl', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        lastindate: new FormItemModel({ caption: '最后入料时间', detailType: 'FORMITEM', name: 'lastindate', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        lastaempid: new FormItemModel({ caption: '最新请购人', detailType: 'FORMITEM', name: 'lastaempid', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        lastaempname: new FormItemModel({ caption: '最新请购人', detailType: 'FORMITEM', name: 'lastaempname', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        emitemid: new FormItemModel({ caption: '物品标识', detailType: 'FORMITEM', name: 'emitemid', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 0 })
, 
    };

    /**
     * 监控表单属性 srfupdatedate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.srfupdatedate')
    onSrfupdatedateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfupdatedate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srforikey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.srforikey')
    onSrforikeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srforikey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfkey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.srfkey')
    onSrfkeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfkey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfmajortext 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.srfmajortext')
    onSrfmajortextChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfmajortext', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srftempmode 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.srftempmode')
    onSrftempmodeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srftempmode', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfuf 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.srfuf')
    onSrfufChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfuf', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfdeid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.srfdeid')
    onSrfdeidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfdeid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfsourcekey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.srfsourcekey')
    onSrfsourcekeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfsourcekey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 storename 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.storename')
    onStorenameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'storename', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 storepartname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.storepartname')
    onStorepartnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'storepartname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 stocksum 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.stocksum')
    onStocksumChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'stocksum', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 unitname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.unitname')
    onUnitnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'unitname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 price 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.price')
    onPriceChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'price', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 amount 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.amount')
    onAmountChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'amount', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 lastsum 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.lastsum')
    onLastsumChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'lastsum', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 highsum 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.highsum')
    onHighsumChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'highsum', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 repsum 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.repsum')
    onRepsumChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'repsum', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 abctype 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.abctype')
    onAbctypeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'abctype', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 lastprice 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.lastprice')
    onLastpriceChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'lastprice', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 sempid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.sempid')
    onSempidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'sempid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 sempname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.sempname')
    onSempnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'sempname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 stockinl 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.stockinl')
    onStockinlChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'stockinl', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 lastindate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.lastindate')
    onLastindateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'lastindate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 lastaempid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.lastaempid')
    onLastaempidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'lastaempid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 lastaempname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.lastaempname')
    onLastaempnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'lastaempname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 emitemid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof StoreBase
     */
    @Watch('data.emitemid')
    onEmitemidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'emitemid', newVal: newVal, oldVal: oldVal });
    }


    /**
     * 显示更多模式切换操作
     *
     * @type {string}
     * @memberof StoreBase
     */
    public manageContainerClick(name: string){
        let model = this.detailsModel[name];
        if(model.isManageContainer){
            model.setManageContainerStatus(!model.manageContainerStatus);
            model.showMoreModeItems.forEach((item:any) => {
                if(this.detailsModel[item].isControlledContent){
                    this.detailsModel[item].setVisible(model.manageContainerStatus? this.detailsModel[item].oldVisible : false);
                }
            });
        }
    }

    /**
     * 重置表单项值
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof StoreBase
     */
    public resetFormData({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
    }

    /**
      * 置空对象
      *
      * @param {any[]} args
     * @memberof StoreBase
      */
    public ResetData(_datas:any){
        if(Object.keys(_datas).length >0){
            Object.keys(_datas).forEach((name: string) => {
                if (this.data.hasOwnProperty(name)) {
                    this.data[name] = null;
                }
            });
        }
    }

    /**
     * 表单逻辑
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof StoreBase
     */
    public formLogic({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
                




























    }

    /**
     * 表单值变化
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @returns {void}
     * @memberof StoreBase
     */
    public formDataChange({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
        if (this.ignorefieldvaluechange) {
            return;
        }
        this.resetFormData({ name: name, newVal: newVal, oldVal: oldVal });
        this.formLogic({ name: name, newVal: newVal, oldVal: oldVal });
        this.dataChang.next(JSON.stringify(this.data));
    }

    /**
     * 表单加载完成
     *
     * @public
     * @param {*} [data={}]
     * @param {string} [action]
     * @memberof StoreBase
     */
    public onFormLoad(data: any = {},action:string): void {
        if(Object.is(action,"save") || Object.is(action,"autoSave") || Object.is(action,"submit"))
        // 更新context的实体主键
        if(data.emitem){
            Object.assign(this.context,{emitem:data.emitem})
        }
        this.setFormEnableCond(data);
        this.fillForm(data,action);
        this.oldData = {};
        Object.assign(this.oldData, JSON.parse(JSON.stringify(this.data)));
        this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: false });
        this.formLogic({ name: '', newVal: null, oldVal: null });
    }

    /**
     * 值填充
     *
     * @param {*} [_datas={}]
     * @param {string} [action]
     * @memberof StoreBase
     */
    public fillForm(_datas: any = {},action:string): void {
        this.ignorefieldvaluechange = true;
        Object.keys(_datas).forEach((name: string) => {
            if (this.data.hasOwnProperty(name)) {
                this.data[name] = _datas[name];
            }
        });
        if(Object.is(action,'loadDraft')){
            this.createDefault();
        }
        if(Object.is(action,'load')){
            this.updateDefault();
        }
        this.$nextTick(function () {
            this.ignorefieldvaluechange = false;
        })
    }

    /**
     * 设置表单项是否启用
     *
     * @public
     * @param {*} data
     * @memberof StoreBase
     */
    public setFormEnableCond(data: any): void {
        Object.values(this.detailsModel).forEach((detail: any) => {
            if (!Object.is(detail.detailType, 'FORMITEM')) {
                return;
            }
            const formItem: FormItemModel = detail;
            formItem.setEnableCond(data.srfuf);
        });
    }

    /**
     * 重置草稿表单状态
     *
     * @public
     * @memberof StoreBase
     */
    public resetDraftFormStates(): void {
        const form: any = this.$refs.form;
        if (form) {
            form.resetFields();
        }
    }

    /**
     * 重置校验结果
     *
     * @memberof StoreBase
     */
    public resetValidates(): void {
        Object.values(this.detailsModel).forEach((detail: any) => {
            if (!Object.is(detail.detailType, 'FORMITEM')) {
                return;
            }
            const formItem: FormItemModel = detail;
            formItem.setError('');
        });
    }

    /**
     * 填充校验结果 （后台）
     *
     * @param {any[]} fieldErrors
     * @memberof StoreBase
     */
    public fillValidates(fieldErrors: any[]): void {
        fieldErrors.forEach((error: any) => {
            const formItem: FormItemModel = this.detailsModel[error.field];
            if (!formItem) {
                return;
            }
            this.$nextTick(() => {
                formItem.setError(error.message);
            });
        });
    }

    /**
     * 表单校验状态
     *
     * @returns {boolean} 
     * @memberof StoreBase
     */
    public formValidateStatus(): boolean {
        const form: any = this.$refs.form;
        let validatestate: boolean = true;
        form.validate((valid: boolean) => {
            validatestate = valid ? true : false;
        });
        return validatestate
    }

    /**
     * 获取全部值
     *
     * @returns {*}
     * @memberof StoreBase
     */
    public getValues(): any {
        return this.data;
    }

    /**
     * 表单项值变更
     *
     * @param {{ name: string, value: any }} $event
     * @returns {void}
     * @memberof StoreBase
     */
    public onFormItemValueChange($event: { name: string, value: any }): void {
        if (!$event) {
            return;
        }
        if (!$event.name || Object.is($event.name, '') || !this.data.hasOwnProperty($event.name)) {
            return;
        }
        this.data[$event.name] = $event.value;
    }

    /**
     * 设置数据项值
     *
     * @param {string} name
     * @param {*} value
     * @returns {void}
     * @memberof StoreBase
     */
    public setDataItemValue(name: string, value: any): void {
        if (!name || Object.is(name, '') || !this.data.hasOwnProperty(name)) {
            return;
        }
        if (Object.is(this.data[name], value)) {
            return;
        }
        this.data[name] = value;
    }



    /**
     * 分组界面行为事件
     *
     * @param {*} $event
     * @memberof StoreBase
     */
    public groupUIActionClick($event: any): void {
        if (!$event) {
            return;
        }
        const item:any = $event.item;
    }

    /**
     * Vue声明周期(处理组件的输入属性)
     *
     * @memberof StoreBase
     */
    public created(): void {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof StoreBase
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                if (Object.is('autoload', action)) {
                    this.autoLoad(data);
                }
                if (Object.is('load', action)) {
                    this.load(data);
                }
                if (Object.is('loaddraft', action)) {
                    if(this.context.srfsourcekey){
                        this.copy(this.context.srfsourcekey);
                    }else{
                        this.loadDraft(data);
                    }
                }
                if (Object.is('save', action)) {
                    this.save(data,data.showResultInfo);
                }
                if (Object.is('remove', action)) {
                    this.remove(data);
                }
                if (Object.is('saveandexit', action)) {
                    this.saveAndExit(data);
                }
                if (Object.is('saveandnew', action)) {
                    this.saveAndNew(data);
                }
                if (Object.is('removeandexit', action)) {
                    this.removeAndExit(data);
                }
                if (Object.is('refresh', action)) {
                    this.refresh(data);
                }
            });
        }
        this.dataChang
            .pipe(
                debounceTime(300),
                distinctUntilChanged()
            ).subscribe((data: any) => {
                if (this.autosave) {
                    this.autoSave();
                }
                const state = !Object.is(JSON.stringify(this.oldData), JSON.stringify(this.data)) ? true : false;
                this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: state });
            });
    }

    /**
     * vue 生命周期
     *
     * @memberof StoreBase
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof StoreBase
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        if (this.dataChangEvent) {
            this.dataChangEvent.unsubscribe();
        }
    }

    /**
     * 拷贝内容
     *
     * @param {*} [arg={}]
     * @memberof @memberof StoreBase
     */
    public copy(srfkey: string): void {
        let copyData = this.$store.getters.getCopyData(srfkey);
        copyData.srfkey = Util.createUUID();
        copyData.emitem = copyData.srfkey;
        copyData.emitemid = copyData.srfkey;
        Object.assign(this.context,{emitem:copyData.emitem})
        this.data = copyData;
        this.$nextTick(() => {
          this.formState.next({ type: 'load', data: copyData });
          this.data.srfuf = '0';
          this.setFormEnableCond(this.data);
        });
    }

    /**
     *打印
     *@memberof @memberof StoreBase
     */
    public print(){
        let _this:any = this;
        _this.$print({id:'emitem_store',popTitle:'物品<主信息>库存信息'});
    }

    /**
     * 部件刷新
     *
     * @param {any[]} args
     * @memberof StoreBase
     */
    public refresh(args: any[]): void {
        let arg: any = {};
        Object.assign(arg,args[0]);
        if (this.data.srfkey && !Object.is(this.data.srfkey, '')) {
            Object.assign(arg, { srfkey: this.data.srfkey });
            this.load(arg);
            return;
        }
        if (this.data.srfkeys && !Object.is(this.data.srfkeys, '')) {
            Object.assign(arg, { srfkey: this.data.srfkeys });
            this.load(arg);
            return;
        }
    }

    /**
     * 自动加载
     *
     * @param {*} [arg={}]
     * @returns {void}
     * @memberof StoreBase
     */
    public autoLoad(arg: any = {}): void {
        if (arg.srfkey && !Object.is(arg.srfkey, '')) {
            Object.assign(arg, { srfkey: arg.srfkey });
            this.load(arg);
            return;
        }
        if (arg.srfkeys && !Object.is(arg.srfkeys, '')) {
            Object.assign(arg, { srfkey: arg.srfkeys });
            this.load(arg);
            return;
        }
        this.loadDraft(arg);
    }

    /**
     * 加载
     *
     * @public
     * @param {*} [opt={}]
     * @memberof StoreBase
     */
    public load(opt: any = {}): void {
        if(!this.loadAction){
            this.$Notice.error({ title: '错误', desc: 'EMItemStoreInfoView视图表单loadAction参数未配置' });
            return;
        }
        const arg: any = { ...opt };
        let viewparamResult:any = Object.assign(arg,this.viewparams);
        const get: Promise<any> = this.service.get(this.loadAction,JSON.parse(JSON.stringify(this.context)),{viewparams:viewparamResult}, this.showBusyIndicator);
        get.then((response: any) => {
            if (response && response.status === 200) {
                const data = response.data;
                this.onFormLoad(data,'load');
                this.$emit('load', data);
                this.$nextTick(() => {
                    this.formState.next({ type: 'load', data: data });
                });
            }
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 加载草稿
     *
     * @param {*} [opt={}]
     * @memberof StoreBase
     */
    public loadDraft(opt: any = {}): void {
        if(!this.loaddraftAction){
            this.$Notice.error({ title: '错误', desc: 'EMItemStoreInfoView视图表单loaddraftAction参数未配置' });
            return;
        }
        const arg: any = { ...opt } ;
        let viewparamResult:any = Object.assign(arg,this.viewparams);
        let post: Promise<any> = this.service.loadDraft(this.loaddraftAction,JSON.parse(JSON.stringify(this.context)),{viewparams:viewparamResult}, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response.status || response.status !== 200) {
                if (response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }

            const data = response.data;
            if(data.emitem){
                Object.assign(this.context,{emitem:data.emitem})
            }
            this.resetDraftFormStates();
            this.onFormLoad(data,'loadDraft');
            this.$emit('load', data);
            this.$nextTick(() => {
                this.formState.next({ type: 'load', data: data });
            });
            setTimeout(() => {
                const form: any = this.$refs.form;
                if (form) {
                    form.fields.forEach((field: any) => {
                        field.validateMessage = "";
                        field.validateState = "";
                        field.validateStatus = false;
                    });
                }
            });
        }).catch((response: any) => {
            if (response && response.status  && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 自动保存
     *
     * @param {*} [opt={}]
     * @memberof StoreBase
     */
    public autoSave(opt: any = {}): void {
        if (!this.formValidateStatus()) {
            return;
        }
        const arg: any = { ...opt };
        const data = this.getValues();
        Object.assign(arg, data);
        const action: any = Object.is(data.srfuf, '1') ? this.updateAction : this.createAction;
        if(!action){
            let actionName:any = Object.is(data.srfuf, '1')?"updateAction":"createAction";
            this.$Notice.error({ title: '错误', desc: 'EMItemStoreInfoView视图表单'+actionName+'参数未配置' });
            return;
        }
        Object.assign(arg,{viewparams:this.viewparams});
        const post: Promise<any> = this.service.add(action, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response.status || response.status !== 200) {
                if (response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }

            const data = response.data;
            this.onFormLoad(data,'autoSave');
            this.$emit('save', data);
            AppCenterService.notifyMessage({name:"EMItem",action:'appRefresh',data:data});
            this.$nextTick(() => {
                this.formState.next({ type: 'save', data: data });
            });
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                if(response.data.errorKey && Object.is(response.data.errorKey,"versionCheck")){
                    this.$Modal.confirm({
                        title: '保存数据发生错误',
                        content: '数据不一致，可能后台数据已经被修改,是否要重新加载数据？',
                        onOk: () => {
                            this.refresh([]);
                        },
                        onCancel: () => { }
                    });
                }else{
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 保存
     *
     * @param {*} [opt={}]
     * @param {boolean} [showResultInfo] 
     * @param {boolean} [ifStateNext] formState是否下发通知
     * @returns {Promise<any>}
     * @memberof StoreBase
     */
    public async save(opt: any = {}, showResultInfo?: boolean, ifStateNext: boolean = true): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            showResultInfo = showResultInfo === undefined ? true : false;
            if (!this.formValidateStatus()) {
                this.$Notice.error({ title: '错误', desc: '值规则校验异常' });
                return;
            }
            const arg: any = { ...opt };
            const data = this.getValues();
            Object.assign(arg, data);
            Object.assign(arg, this.context);
            if (ifStateNext) {
                this.drcounter = 0;
                if(this.drcounter !== 0){
                    this.drsaveopt = opt;
                    this.formState.next({ type: 'beforesave', data: arg });//先通知关系界面保存
                    this.saveState = resolve;
                    return;
                }
            }
            const action: any = Object.is(data.srfuf, '1') ? this.updateAction : this.createAction;
            if(!action){
                let actionName:any = Object.is(data.srfuf, '1')?"updateAction":"createAction";
                this.$Notice.error({ title: '错误', desc: 'EMItemStoreInfoView视图表单'+actionName+'参数未配置' });
                return;
            }
            Object.assign(arg,{viewparams:this.viewparams});
            const post: Promise<any> = Object.is(data.srfuf, '1')?this.service.update(action, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator):this.service.add(action,JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
            post.then((response: any) => {
                if (!response.status || response.status !== 200) {
                    if (response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                    }
                    return;
                }

                const data = response.data;
                this.onFormLoad(data,'save');
                this.$emit('save', data);
                AppCenterService.notifyMessage({name:"EMItem",action:'appRefresh',data:data});
                this.$nextTick(() => {
                    this.formState.next({ type: 'save', data: data });
                });
                if (showResultInfo) {
                    this.$Notice.success({ title: '', desc: (data.srfmajortext ? data.srfmajortext : '') + '&nbsp;保存成功！' });
                }
                resolve(response);
            }).catch((response: any) => {
                if (response && response.status  && response.data) {
                    if(response.data.errorKey && Object.is(response.data.errorKey,"versionCheck")){
                        this.$Modal.confirm({
                            title: '保存数据发生错误',
                            content: '数据不一致，可能后台数据已经被修改,是否要重新加载数据？',
                            onOk: () => {
                                this.refresh([]);
                            },
                            onCancel: () => { }
                        });
                    }else{
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                    }
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
        })
    }

    /**
    * 删除
    *
    * @public
    * @param {*} [opt={}]
    * @memberof StoreBase
    */
    public remove(opt:Array<any> = [],showResultInfo?: boolean): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            if(!this.removeAction){
                this.$Notice.error({ title: '错误', desc: 'EMItemStoreInfoView视图表单removeAction参数未配置' });
                return;
            }
            const arg: any = opt[0];
            const _this: any = this;
            Object.assign(arg,{viewparams:this.viewparams});
            this.service.delete(_this.removeAction, JSON.parse(JSON.stringify(this.context)),arg, showResultInfo).then((response: any) => {
                if (response) {
                    const data = response.data;
                    this.$emit('remove',data);
                    this.formState.next({ type: 'remove', data: data });
                    this.data.ismodify = false;
                    this.$Notice.success({ title: '', desc: (data.srfmajortext ? data.srfmajortext : '') + '&nbsp;删除成功！' });
                    AppCenterService.notifyMessage({name:"EMItem",action:'appRefresh',data:data});
                    resolve(response);
                }
            }).catch((error: any) => {
                const { data: _data } = error;
                this.$Notice.error({ title: _data.title, desc: _data.message });
                reject(error);
            });
        });
    }

    /**
     * 工作流启动
     *
     * @param {*} [data={}]
     * @param {*} [localdata={}]
     * @returns {Promise<any>}
     * @memberof StoreBase
     */
    public async wfstart(data: any,localdata?:any): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            const _this: any = this;
            const post: Promise<any> = _this.save({},false);
            post.then((response:any) =>{
                const arg:any = response.data;
                if(this.viewparams){
                    Object.assign(arg,{viewparams:this.viewparams});
                }
                const result: Promise<any> = this.service.wfstart(_this.WFStartAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator,localdata);
                result.then((response: any) => {
                    if (!response || response.status !== 200) {
                        if(response.data){
                            this.$Notice.error({ title: '', desc: '工作流启动失败, ' + response.data.message });
                        }
                        return;
                    }
                    this.$Notice.info({ title: '', desc: '工作流启动成功' });
                    resolve(response);
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
            }).catch((response: any) => {
                    if (response && response.status && response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: '错误', desc: '系统异常' });
                        reject(response);
                        return;
                    }
                    reject(response);
            })
        });
    }

    /**
     * 工作流提交
     *
     * @param {*} [data={}]
     * @param {*} [localdata={}]
     * @returns {Promise<any>}
     * @memberof StoreBase
     */
    public async wfsubmit(data: any,localdata?:any): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
        const _this: any = this;
        const arg: any = data[0];
        Object.assign(arg,{viewparams:this.viewparams});
        if (!arg.emitem || Object.is(arg.emitem, '')) {
            return;
        }
        const post: Promise<any> = Object.is(arg.srfuf, '1')?this.service.update(this.updateAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator):this.service.add(this.createAction,JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
        post.then((response:any) =>{
                const arg:any = response.data;
                // 保存完成UI处理
                this.onFormLoad(arg,'save');
                this.$emit('save', arg);
                AppCenterService.notifyMessage({name:"EMItem",action:'appRefresh',data:data});
                this.$nextTick(() => {
                    this.formState.next({ type: 'save', data: arg });
                });
                // 准备提交参数
                if(this.viewparams){
                    Object.assign(arg,{viewparams:this.viewparams});
                }
                // 强制补充srfwfmemo
                if(this.srfwfmemo){
                    Object.assign(arg,{srfwfmemo:this.srfwfmemo});
                }
                const result: Promise<any> = this.service.wfsubmit(_this.WFSubmitAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator,localdata);
                result.then((response: any) => {
                    if (!response || response.status !== 200) {
                        if(response.data){
                            this.$Notice.error({ title: '', desc: '工作流提交失败, ' + response.data.message });
                        }
                        return;
                    }
                    this.onFormLoad(arg,'submit');
                    this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
                    this.$Notice.info({ title: '', desc: '工作流提交成功' });
                    resolve(response);
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
            }).catch((response: any) => {
                    if (response && response.status && response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: '错误', desc: '系统异常' });
                        reject(response);
                        return;
                    }
                    reject(response);
            })
        })
    }

    /**
     * 表单项更新
     *
     * @param {string} mode 界面行为名称
     * @param {*} [data={}] 请求数据
     * @param {string[]} updateDetails 更新项
     * @param {boolean} [showloading] 是否显示加载状态
     * @returns {void}
     * @memberof StoreBase
     */
    public updateFormItems(mode: string, data: any = {}, updateDetails: string[], showloading?: boolean): void {
        if (!mode || (mode && Object.is(mode, ''))) {
            return;
        }
        const arg: any = { ...data };
        Object.assign(arg,this.viewparams);
        const post: Promise<any> = this.service.frontLogic(mode,JSON.parse(JSON.stringify(this.context)),arg, showloading);
        post.then((response: any) => {
            if (!response || response.status !== 200) {
                this.$Notice.error({ title: '错误', desc: '表单项更新失败' });
                return;
            }
            const data = response.data;
            const _data: any = {};
            updateDetails.forEach((name: string) => {
                if (!data.hasOwnProperty(name)) {
                    return;
                }
                Object.assign(_data, { [name]: data[name] });
            });
            this.setFormEnableCond(_data);
            this.fillForm(_data,'updateFormItem');
            this.formLogic({ name: '', newVal: null, oldVal: null });
            this.dataChang.next(JSON.stringify(this.data));
            AppCenterService.notifyMessage({name:"EMItem",action:'appRefresh',data:data});
            this.$nextTick(() => {
                this.formState.next({ type: 'updateformitem', ufimode: arg.srfufimode, data: _data });
            });
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 回车事件
     *
     * @param {*} $event
     * @memberof StoreBase
     */
    public onEnter($event: any): void {
    }

    /**
     * 保存并退出
     *
     * @param {any[]} args
     * @memberof StoreBase
     */
    public saveAndExit(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.currentAction = "saveAndExit";
            _this.save([arg]).then((res) =>{
                if(res){
                    _this.closeView(res.data);
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
     * 保存并新建
     *
     * @param {any[]} args
     * @memberof StoreBase
     */
    public saveAndNew(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.currentAction = "saveAndNew";
            _this.save([arg]).then((res) =>{
                _this.ResetData(res);
                _this.loadDraft({});
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
     * 删除并退出
     *
     * @param {any[]} args
     * @memberof StoreBase
     */
    public removeAndExit(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.remove([arg]).then((res) =>{
                if(res){
                  _this.closeView(res.data);
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
    * 关系界面数据保存完成
    *
    * @param {any} $event
    * @memberof StoreBase
    */
    public drdatasaved($event:any){
        let _this = this;
        this.drcounter--;
        if(this.drcounter === 0){
            this.save(this.drsaveopt, undefined, false).then((res) =>{
                this.saveState(res);
                this.drsaveopt = {};
                if(Object.is(_this.currentAction, "saveAndNew")){
                    _this.ResetData(res);
                    _this.loadDraft({});
                }else if(Object.is(_this.currentAction, "saveAndExit")){
                    if(res){
                        _this.closeView(res.data);
                    }
                }
            });
        }
    }

    /**
     * 新建默认值
     * @memberof StoreBase
     */
    public createDefault(){                    
        if (this.data.hasOwnProperty('stocksum')) {
            this.data['stocksum'] = 0;
        }
    }

    /**
     * 更新默认值
     * @memberof StoreBase
     */
    public updateDefault(){                    
    }

    
}
</script>

<style lang='less'>
@import './store-form.less';
</style>